package gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLConnection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Random;
import java.util.Scanner;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MainFrame10 extends JApplet implements ActionListener, KeyListener {

	final static String url_addr = "http://www.student.dtu.dk/~seka";

	JButton exp1But, exp2But, exp3But;
	ResourceWaiterButton startBut;
	ResourceWaiterButton continueBut;
	JTextField attendantName;
	JTextField attendantAge;
	JTextField attendantOccupation;
	JLabel attendantLang;
	JLabel attendantGend;
	String attendantNameString;
	String attendantAgeString;
	String attendantOccString;
	String attendantLangString;
	String attendantGendString;
	File userFolder;
	String nameString = "Insert Name";
	String ageString = "Insert Age";
	String occString = "Insert Occupation";
	String langString = "English Fluency:";
	JRadioButton LangBut1;
	JRadioButton LangBut2;
	JRadioButton LangBut3;
	JRadioButton LangBut4;
	JRadioButton GendBut1;
	JRadioButton GendBut2;
	String langString1 = "Mother Tongue";
	String langString2 = "Fluent";
	String langString3 = "Medium";
	String langString4 = "Basic";
	int numberClips=61;
	ExperimentData experimentData;
	String genderString = "Gender: ";
	String genderString1 = "Female";
	String genderString2 = "Male";
	JButton questionsBut;
	String lineEnd = "\r\n";


	Vector<String> sounds= new Vector<String>();
	Vector<String> sounds1= new Vector<String>();
	Vector<String> sounds2= new Vector<String>();
	Vector<String> sounds3= new Vector<String>();

	Vector<String> srt = new  Vector<String>();
	Vector<String> srt1 = new  Vector<String>();
	Vector<String> srt2 = new  Vector<String>();
	Vector<String> srt3 = new  Vector<String>();

	Vector<String> zamanlarsrt = new  Vector<String>();
	Vector<String> zamanlarsrt1 = new  Vector<String>();
	Vector<String> zamanlarsrt2 = new  Vector<String>();
	Vector<String> zamanlarsrt3 = new  Vector<String>();

	MemorizeExperimentDialogSubtitles exp1Frame;
	MemorizeExperimentDialogSubtitles exp2Frame;
	MemorizeExperimentDialogSubtitles exp3Frame;
	
	Questionnaire questFrame;

	String generalInstructions="Instructions \n";
	Vector<String> exp1items = new Vector<String>();
	


	public void init(){
		//super();

		//File resultsFolder = new File("results");
		//if(!resultsFolder.exists()) resultsFolder.mkdir(); 

		int buttonWidth = 200, buttonHeight = 80;

		Container cPane = getContentPane();

		GridLayout mainLayout = new GridLayout(7,1);

		cPane.setLayout(mainLayout);


		exp1But = new JButton("EXP 1");
		exp1But.setPreferredSize(new Dimension(buttonWidth, buttonHeight));
		exp1But.setEnabled(false);

		exp2But = new JButton("EXP 2");
		exp2But.setPreferredSize(new Dimension(buttonWidth, buttonHeight));
		exp2But.setEnabled(false);

		exp3But = new JButton("EXP 3");
		exp3But.setPreferredSize(new Dimension(buttonWidth, buttonHeight));
		exp3But.setEnabled(false);

		questionsBut= new JButton("Questionnaire");
		questionsBut.addActionListener(this);
		questionsBut.setEnabled(false);
		JPanel questPane = new JPanel();
		questPane.setLayout(new GridLayout(1,1));
		questPane.add(questionsBut);
		
		questFrame = new Questionnaire(MainFrame10.this, attendantNameString);

		// Font font1 = new Font("Book Antiqua", Font.PLAIN, 40);





		JPanel expPanel = new JPanel();
		GridLayout experimentsLayout = new GridLayout(1,1);
		expPanel.setLayout(experimentsLayout);

		JPanel expPane2 = new JPanel();
		expPane2.setLayout(experimentsLayout);

		JPanel expPane3 = new JPanel();
		expPane3.setLayout(experimentsLayout);

		expPanel.add(exp1But);
		expPane2.add(exp2But);
		expPane3.add(exp3But);

		experimentData = new ExperimentData();

		attendantName = new JTextField(nameString);
		attendantName.setPreferredSize(new Dimension(200, 15));
		attendantName.addKeyListener(this);
		startBut = new ResourceWaiterButton("Start", "Loading the resources...");
		startBut.setPreferredSize(new Dimension(200, 15));
		startBut.setEnabled(false);
		startBut.setResource(experimentData);
		continueBut = new ResourceWaiterButton("Continue", "Loading the resources...");
		continueBut.setPreferredSize(new Dimension(200, 15));
		continueBut.setEnabled(false);
		continueBut.setResource(experimentData);
		attendantAge = new JTextField(ageString);
		attendantAge.setPreferredSize(new Dimension(200, 15));
		attendantAge.addKeyListener(this);
		attendantOccupation = new JTextField(occString);
		attendantOccupation.setPreferredSize(new Dimension(200, 15));
		attendantOccupation.addKeyListener(this);
		attendantLang = new JLabel(langString);
		attendantLang.setPreferredSize(new Dimension(200, 15));
		attendantGend = new JLabel(genderString);
		attendantGend.setPreferredSize(new Dimension(100, 15));




		LangBut1 = new JRadioButton(langString1);
		LangBut2 = new JRadioButton(langString2);
		LangBut3 = new JRadioButton(langString3);
		LangBut4 = new JRadioButton(langString4);

		ButtonGroup groupBut = new ButtonGroup();
		groupBut.add(LangBut1);
		groupBut.add(LangBut2);
		groupBut.add(LangBut3);
		groupBut.add(LangBut4);

		LangBut1.setSelected(false);
		LangBut2.setSelected(false);
		LangBut3.setSelected(false);
		LangBut4.setSelected(false);

		LangBut1.addActionListener(this);
		LangBut2.addActionListener(this);
		LangBut3.addActionListener(this);
		LangBut4.addActionListener(this);
		
		GendBut1 = new JRadioButton(genderString1);
		GendBut2 = new JRadioButton(genderString2);

		ButtonGroup groupButGend = new ButtonGroup();
		groupButGend.add(GendBut1);
		groupButGend.add(GendBut2);

		GendBut1.setSelected(false);
		GendBut2.setSelected(false);

		GendBut1.addActionListener(this);
		GendBut2.addActionListener(this);

		JPanel gendPane = new JPanel();
		gendPane.setLayout(new GridBagLayout());
		gendPane.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c0 = new GridBagConstraints();
		c0.anchor = GridBagConstraints.CENTER;
		c0.fill = GridBagConstraints.HORIZONTAL;
		c0.gridx = 0;
		c0.gridy = 0;
		c0.weightx = 1.0;
		c0.gridwidth = 2;
		gendPane.add(attendantGend,c0);
		c0.fill = GridBagConstraints.HORIZONTAL;
		c0.gridx = 0;
		c0.gridy = 1;
		c0.weightx = 1.0;
		c0.gridwidth = 1;
		gendPane.add(GendBut1,c0);
		c0.fill = GridBagConstraints.HORIZONTAL;
		c0.gridx = 1;
		c0.gridy = 1;
		c0.weightx = 1.0;
		c0.gridwidth = 1;
		gendPane.add(GendBut2,c0);

		JPanel attPane1 = new JPanel();
		GridLayout attLayout = new GridLayout(1,4);
		attPane1.setLayout(attLayout);
		attPane1.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		//		attPane1.setBorder(BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

		
		
		attPane1.add(attendantName);
		attPane1.add(attendantOccupation);
		attPane1.add(attendantAge);
		attPane1.add(gendPane);

		JPanel attPane2 = new JPanel();
		GridBagLayout attLayout2 = new GridBagLayout();
		attPane2.setLayout(attLayout2);
		attPane2.setBorder(BorderFactory.createLineBorder(Color.GRAY));


		GridBagConstraints c = new GridBagConstraints();
		c.anchor = GridBagConstraints.CENTER;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 1.0;
		c.gridwidth = 4;
		attPane2.add(attendantLang,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 0;
		c.gridy = 1;
		c.weightx = 1.0;
		c.gridwidth = 1;
		attPane2.add(LangBut1,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 1;
		c.gridy = 1;
		c.weightx = 1.0;
		c.gridwidth = 1;
		attPane2.add(LangBut2,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 2;
		c.gridy = 1;
		c.weightx = 1.0;
		c.gridwidth = 1;
		attPane2.add(LangBut3,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 3;
		c.gridy = 1;
		c.weightx = 1.0;
		c.gridwidth = 1;
		attPane2.add(LangBut4,c);


		//attPane2.add(startBut);

		JPanel startPane = new JPanel();
		GridLayout startLayout = new GridLayout(2,1);
		startPane.setLayout(startLayout);

		startPane.add(startBut);
		startPane.add(continueBut);

		//cPane.add(attendantName);
		//cPane.add(startBut);
		cPane.add(attPane1);
		cPane.add(attPane2);
		cPane.add(startPane);
		cPane.add(expPanel);
		cPane.add(expPane2);
		cPane.add(expPane3);
		cPane.add(questPane);





		startBut.addActionListener(this);
		continueBut.addActionListener(this);
		exp1But.addActionListener(this);
		exp2But.addActionListener(this);
		exp3But.addActionListener(this);
		LangBut1.addActionListener(this);
		LangBut2.addActionListener(this);
		LangBut3.addActionListener(this);
		LangBut4.addActionListener(this);


		exp1items.add("");
		exp1items.add("");
		exp1items.add("");
		exp1items.add("");
		exp1items.add("");
		exp1items.add("");
		exp1items.add("");
		exp1items.add("");
		exp1items.add("");

		experimentData.execute();


		//	    srt.removeAllElements();
		//	    srt.add("RM.srt");







		//	setResizable(false); // not applicable to JApplet



		/*		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});*/  // not applicable to JApplet

		//	pack(); // not applicable to JApplet
		// show();
		setSize(700, 400);
		setPreferredSize(new Dimension(700, 400));
		validate();
		//centerWindow(this);
		//setVisible(true);

	}


	public static void centerWindow(Component window) {
		// Get the size of the screen
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();

		// Determine the new location of the window
		int w = window.getSize().width;
		int h = window.getSize().height;
		int x = (dim.width-w)/2;
		int y = (dim.height-h)/2;

		// Move the window
		window.setLocation(x, y);

	}

	/*	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
					MainFrame frame = new MainFrame();
			}});
	}*/

	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==LangBut1){
			attendantLangString = langString1;
		}
		if(e.getSource()==LangBut2){
			attendantLangString =langString2;
		}
		if(e.getSource()==LangBut3){
			attendantLangString = langString3;
		}
		if(e.getSource()==LangBut4){
			attendantLangString = langString4;
		}

		if((e.getSource().getClass()==JRadioButton.class || e.getSource()==attendantName) && checkAttendantInfo()) {
			startBut.setEnabled(true);
			continueBut.setEnabled(true);
		}

		if(e.getSource()==GendBut1){
			attendantGendString = genderString1;
		}
		if(e.getSource()==GendBut2){
			attendantGendString =genderString2;
		}

		if(e.getSource()==startBut && attendantName.getText().compareTo(nameString)!=0 && attendantAge.getText().compareTo(ageString)!=0 && attendantOccupation.getText().compareTo(occString)!=0 && (LangBut1.isSelected() || LangBut2.isSelected() || LangBut3.isSelected() || LangBut4.isSelected() )  && (GendBut1.isSelected() || GendBut2.isSelected()  )) {

			attendantNameString = attendantName.getText().replace(' ', '_');

			String folderName = ReadDoneResults(attendantNameString);

			if(folderName!=null){
				Component frame = null;
				JOptionPane.showMessageDialog(frame, "Your name is already used, please change it (add some letters, numbers etc. at the end) to start the experiments. \n Or if you are trying to continue from where you left last time, please press the 'continue' button instead.",    "Error", JOptionPane.ERROR_MESSAGE);
			}
			else{

				startBut.setEnabled(false);
				continueBut.setEnabled(false);
				attendantName.setEnabled(false);
				attendantAge.setEnabled(false);
				attendantOccupation.setEnabled(false);
				LangBut1.setEnabled(false);
				LangBut2.setEnabled(false);
				LangBut3.setEnabled(false);
				LangBut4.setEnabled(false);
				String time_out = CurrentTime();
				attendantAgeString = attendantAge.getText().replace(' ', '_');
				attendantOccString = attendantOccupation.getText().replace(' ', '_');

				final String personal_info = attendantNameString + "\r\n" + attendantAgeString + "\r\n" + attendantOccString+ "\r\n" + attendantLangString + "\r\n" + attendantGendString;
				attendantNameString = attendantNameString + "_" + time_out;


				new Thread() {
					@Override
					public void run() {
						boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, "personal_info.dat", personal_info  );
						if(!success){
							WriteSuccessError();
						}
					}
				}.start();

				SwingUtilities.invokeLater(new Runnable() {
					int count=0; 
					@Override
					public void run() {
						switch (count) {
						case 0:
							startBut.setText("Starting.");
							exp1Frame = new MemorizeExperimentDialogSubtitles(MainFrame10.this, "Experiment 1",
									generalInstructions, "exp1", "audio/drum_roll_3.wav", sounds1, srt1, zamanlarsrt1, 0, exp2But);
							count++;
							break;
						case 1:
							startBut.setText("Starting..");
							exp2Frame = new MemorizeExperimentDialogSubtitles(MainFrame10.this, "Experiment 2",
									generalInstructions, "exp2", "audio/drum_roll_3.wav", sounds2, srt2, zamanlarsrt2, 1, exp3But);
							count++;
							break;
						case 2:
							startBut.setText("Starting...");
							exp3Frame = new MemorizeExperimentDialogSubtitles(MainFrame10.this, "Experiment 3",
									generalInstructions, "exp3", "audio/drum_roll_3.wav", sounds3, srt3, zamanlarsrt3, 2, questionsBut);
							count++;
							break;
						case 3:
							startBut.setText("Start");
							exp1Frame.setAttendantNameString(attendantNameString);
							exp2Frame.setAttendantNameString(attendantNameString);
							exp3Frame.setAttendantNameString(attendantNameString);
							questFrame.setAttendantNameString(attendantNameString);

							exp1But.setEnabled(true);
							//exp2But.setEnabled(true);
							//exp3But.setEnabled(true);
							return;
						}
						SwingUtilities.invokeLater(this);
					}
				});
			
			}

		} else if(e.getSource()==continueBut && attendantName.getText().compareTo(nameString)!=0 && attendantAge.getText().compareTo(ageString)!=0 && attendantOccupation.getText().compareTo(occString)!=0 && (LangBut1.isSelected() || LangBut2.isSelected() || LangBut3.isSelected() || LangBut4.isSelected() ) && (GendBut1.isSelected() || GendBut2.isSelected()  )) {
			
			
			
			continueBut.setEnabled(false);
			String attendantNameString2 = attendantName.getText().replace(' ', '_');

			attendantNameString = ReadDoneResults(attendantNameString2);
			if(attendantNameString==null){
				Component frame = null;
				JOptionPane.showMessageDialog(frame, " You did not do this experiment before, so you can not resume. Please press the 'start' button instead.\n Or please check if you are entering the name you used before correctly.",    "Error", JOptionPane.ERROR_MESSAGE);
			}else{
				
				JOptionPane.showMessageDialog(null, "You will continue from where you left last time. \n Please just be sure you entered the same name you used before! \n If you are sure, you can ignore this message. \n If you are not, please restart the webpage, and enter the correct name.");

				
				boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, "continue_log.dat", CurrentDate() + lineEnd );
				if(!success){
					WriteSuccessError();
				}
				
				startBut.setEnabled(false);
				attendantName.setEnabled(false);
				attendantAge.setEnabled(false);
				attendantOccupation.setEnabled(false);
				LangBut1.setEnabled(false);
				LangBut2.setEnabled(false);
				LangBut3.setEnabled(false);
				LangBut4.setEnabled(false);


				soundsToRemove("exp10__ratings.dat",sounds1, srt1, zamanlarsrt1);
				soundsToRemove("exp20__ratings.dat",sounds2, srt2, zamanlarsrt2);
				soundsToRemove("exp30__ratings.dat",sounds3, srt3, zamanlarsrt3);

				/* TODO Bi alt fonksiyonu ustteki sonuclara gore duzenle
				 * 
				 */

				SwingUtilities.invokeLater(new Runnable() {
					int count=0; 
					@Override
					public void run() {
						switch (count) {
						case 0:
							continueBut.setText("Starting.");
							if(sounds1.size()>0){
								exp1Frame = new MemorizeExperimentDialogSubtitles(MainFrame10.this, "Experiment 1",
										generalInstructions, "exp1", "audio/drum_roll_3.wav", sounds1, srt1, zamanlarsrt1, 0, exp2But);
								exp1But.setEnabled(true);

							}
							else{
								exp1But.setEnabled(false);
							}
							count++;
							break;
						case 1:
							continueBut.setText("Starting..");
							if(sounds2.size()>0){
								exp2Frame = new MemorizeExperimentDialogSubtitles(MainFrame10.this, "Experiment 2",
										generalInstructions, "exp2", "audio/drum_roll_3.wav", sounds2, srt2, zamanlarsrt2, 1, exp3But);
								if(sounds1.size()==0)
									exp2But.setEnabled(true);
							}
							else{
								exp2But.setEnabled(false);
							}
							count++;
							break;
						case 2:
							continueBut.setText("Starting...");
							if(sounds3.size()>0){
								exp3Frame = new MemorizeExperimentDialogSubtitles(MainFrame10.this, "Experiment 3",
										generalInstructions, "exp3", "audio/drum_roll_3.wav", sounds3, srt3, zamanlarsrt3, 2, questionsBut);
								if(sounds2.size()==0)
									exp3But.setEnabled(true);
							}
							else{
								questionsBut.setEnabled(true);
							}
							count++;
							break;
						case 3:
							startBut.setText("Start");
							if(sounds1.size()>0){
								exp1Frame.setAttendantNameString(attendantNameString);
								exp1But.setEnabled(true);
							}
							if(sounds2.size()>0)
								exp2Frame.setAttendantNameString(attendantNameString);
							if(sounds3.size()>0)
								exp3Frame.setAttendantNameString(attendantNameString);
							
							questFrame.setAttendantNameString(attendantNameString);

							

							return;
						}
						SwingUtilities.invokeLater(this);
					}
				});

			}

		} else if(e.getSource()==exp1But) {
			exp1Frame.setVisible(true);
		}	
		else if(e.getSource()==exp2But) {
			exp2Frame.setVisible(true);
		}	
		else if(e.getSource()==exp3But) {
			exp3Frame.setVisible(true);
		}	
		else if(e.getSource()==questionsBut){
			questFrame.setVisible(true);
		}

	}


	private String ReadDoneResults(String attendantNameString2) {
		String folderName=null;

		URLConnection connection = null;
		try {
			connection = new URL(url_addr+"/Results").openConnection();
		} catch (MalformedURLException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		String resultsFolder = null;
		try {
			resultsFolder  = new Scanner(connection.getInputStream()).useDelimiter("\\Z").next();
			Pattern p = Pattern.compile("<a href=\"("+attendantNameString2+"_\\d*)/\">");
			Matcher m = p.matcher(resultsFolder);
			while (m.find()){
				System.out.println("Found comment: "+m.group(1));
				folderName=m.group(1);
			}
		} catch (IOException e1) {
			e1.printStackTrace();
		}


		return folderName;


	}

	private void soundsToRemove(String fileNameString, Vector<String> soundsOriginal, Vector<String> srtOriginal, Vector<String> zamanlarOriginal ) {

		URLConnection connection;
		try {
			connection = new URL(url_addr + "/Results/"+attendantNameString+"/"+fileNameString).openConnection();
			String srt_in  = new Scanner(connection.getInputStream()).useDelimiter("\\Z").next();
			BufferedReader br1 = new BufferedReader(new StringReader(srt_in));
			String line = br1.readLine();
			String allLines=line;
			while(line != null){
				line = br1.readLine();
				allLines = allLines+line;
			}
			int count_i=0;
			for (int i = 0; i < soundsOriginal.capacity(); i++) {
				if (allLines.contains(soundsOriginal.elementAt(count_i))){
					soundsOriginal.remove(count_i);
					srtOriginal.remove(count_i);
					zamanlarOriginal.remove(count_i);

				}else
					count_i=count_i+1;

			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			return;
		}





	}


	public void Shuffle(){
		Random r = new Random(); 
		int len = sounds.size();

		for (int i=0; i<len; i++) {
			int randomPosition = r.nextInt(len-1);


			String temp = sounds.elementAt(i);
			sounds.insertElementAt(sounds.elementAt(randomPosition), i);
			sounds.remove(i+1);
			sounds.insertElementAt(temp, randomPosition);
			sounds.remove(randomPosition+1);

			temp =srt.elementAt(i);
			srt.insertElementAt(srt.elementAt(randomPosition), i);
			srt.remove(i+1);
			srt.insertElementAt(temp, randomPosition);
			srt.remove(randomPosition+1);

			temp =zamanlarsrt.elementAt(i);
			zamanlarsrt.insertElementAt(zamanlarsrt.elementAt(randomPosition), i);
			zamanlarsrt.remove(i+1);
			zamanlarsrt.insertElementAt(temp, randomPosition);
			zamanlarsrt.remove(randomPosition+1);
		}
	}

	public String CurrentTime(){

		Calendar calendar = new GregorianCalendar();
		String am_pm;

		int hour = calendar.get(Calendar.HOUR_OF_DAY);
		int minute = calendar.get(Calendar.MINUTE);
		int second = calendar.get(Calendar.SECOND);
		String hourStr;
		String minStr;
		String secStr;
		if(hour<10){
			hourStr = Integer.toString(0)  + Integer.toString(hour);
		} 
		else{
			hourStr =  Integer.toString(hour);
		}
		if(minute<10){
			minStr = Integer.toString(0)  + Integer.toString(minute);
		} 
		else{
			minStr =  Integer.toString(minute);
		}
		if(second<10){
			secStr = Integer.toString(0)  + Integer.toString(second);
		} 
		else{
			secStr =  Integer.toString(second);
		}
		String time_out = hourStr+minStr+secStr;
		return time_out;
	}

	public static void WriteSuccessError(){
		JOptionPane.showMessageDialog(null, "The connection is lost!\n Please check your connection and reload the page.", 
				"Error!", JOptionPane.INFORMATION_MESSAGE);
	}
	
	public String CurrentDate(){

        DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        Date date = new Date();
        return dateFormat.format(date);
	}


	@Override
	public void keyPressed(KeyEvent arg0) {
		if(checkAttendantInfo()){
			startBut.setEnabled(true);
			continueBut.setEnabled(true);
		}
	}

	@Override	public void keyReleased(KeyEvent arg0) {}
	@Override	public void keyTyped(KeyEvent arg0) {}

	private boolean checkAttendantInfo() {
		boolean textSet = !attendantAge.getText().equals(ageString) &&
				!attendantName.getText().equals(nameString) &&
				!attendantOccupation.getText().equals(occString);
		boolean langSet = LangBut1.isSelected() || LangBut2.isSelected() || LangBut3.isSelected() || LangBut4.isSelected();
		boolean gendSet = GendBut1.isSelected() || GendBut2.isSelected() ;
		return textSet && langSet && gendSet;
	}

	public class ExperimentData extends SwingWorker<Boolean, Double> implements LoadableResource {

		boolean isReady;
		boolean isValid;
		double progress;

		public ExperimentData() {
			isReady=false;
			isValid=true;
			progress = 0;
		}

		@Override
		protected Boolean doInBackground() throws Exception {
			boolean result;
			try {

				URLConnection connection = new URL(url_addr + "/text/Instructions.txt").openConnection();
				generalInstructions  = new Scanner(connection.getInputStream()).useDelimiter("\\Z").next();


				progress = 0.05;

				connection = new URL(url_addr + "/text/wav_names_try.txt").openConnection();
				String sound_in  = new Scanner(connection.getInputStream()).useDelimiter("\\Z").next();
				BufferedReader br1 = new BufferedReader(new StringReader(sound_in));
				String line = br1.readLine();
				while(line != null){
					sounds.add(line);
					line = br1.readLine();
				}

				progress = 0.1;

				connection = new URL(url_addr + "/text/srt_names_try.txt").openConnection();
				String srt_in  = new Scanner(connection.getInputStream()).useDelimiter("\\Z").next();
				br1 = new BufferedReader(new StringReader(srt_in));
				line = br1.readLine();
				while(line != null){
					srt.add(line);
					line = br1.readLine();
				}

				progress = 0.15;

				connection = new URL(url_addr + "/text/zamanlar_srt_try2.txt").openConnection();
				String zamanlar_in  = new Scanner(connection.getInputStream()).useDelimiter("\\Z").next();
				br1 = new BufferedReader(new StringReader(zamanlar_in));
				line = br1.readLine();
				while(line != null){
					zamanlarsrt.add(line);
					line = br1.readLine();
				}
				progress = 0.2;
				ExperimentDialog.downloadSAM();

				progress = 0.4;
				FormDialogSubtitles.downloadImagesV();

				progress = 0.7;
				FormDialogSubtitles.downloadImagesA();

				progress = 1;

				isReady=true;
				result = true;
			} catch (MalformedURLException eurl) {
				eurl.printStackTrace();
				isValid = false;
				result = false;
			} catch (IOException econ2) {
				isValid = false;
				econ2.printStackTrace();
				result = false;
			}

			synchronized (this) {
				notifyAll();
			}

			return result;
		}

		@Override
		public boolean isReady() {
			return isReady;
		}

		@Override
		public boolean isValid() {
			return isValid;
		}

		@Override
		public double progress() {
			return progress;
		}

		@Override
		public synchronized boolean waitUntilReady() {
			if(isReady) return true;
			else if(!isValid) return false;
			while(!isReady&&isValid) {
				try {
					wait();
				} catch (InterruptedException e) {}
			}
			if(isReady) return true;
			else return false;

		}		

		@Override
		protected void done() {
			boolean result;
			try {
				result = get();
			} catch (Exception e) {
				result = false;
			}
			if(!result) {
				JOptionPane.showMessageDialog(null, "Could not download the necessary files!", 
						"Error!", JOptionPane.INFORMATION_MESSAGE);
			}



			Shuffle();

			sounds.insertElementAt("audio/CR.1.wav", 0);
			sounds.insertElementAt("audio/RM.3.wav", 1);
			srt.insertElementAt("text/CR.srt", 0);
			srt.insertElementAt("text/RM.srt", 1);
			zamanlarsrt.insertElementAt("37. 00:03:49  00:03:59 Complaint (negative valence, neutral arousal", 0);
			zamanlarsrt.insertElementAt("5. 00:56:27  00:56:45 Neutral, Content", 1);
			Vector<String> filesToCache = new Vector<String>();
			filesToCache.addAll(srt);

			sounds1=(Vector<String>) sounds.clone();
			srt1=(Vector<String>) srt.clone();
			zamanlarsrt1=(Vector<String>) zamanlarsrt.clone();

			sounds.remove(0);
			sounds.remove(0);
			srt.remove(0);
			srt.remove(0);
			zamanlarsrt.remove(0);
			zamanlarsrt.remove(0);

			Shuffle();

			sounds.insertElementAt("audio/CR.1.wav", 0);
			sounds.insertElementAt("audio/RM.3.wav", 1);
			srt.insertElementAt("text/CR.srt", 0);
			srt.insertElementAt("text/RM.srt", 1);
			zamanlarsrt.insertElementAt("37. 00:03:49  00:03:59 Complaint (negative valence, neutral arousal", 0);
			zamanlarsrt.insertElementAt("5. 00:56:27  00:56:45 Neutral, Content", 1);

			sounds2=(Vector<String>) sounds.clone();
			srt2=(Vector<String>) srt.clone();
			zamanlarsrt2=(Vector<String>) zamanlarsrt.clone();

			sounds.remove(0);
			sounds.remove(0);
			srt.remove(0);
			srt.remove(0);
			zamanlarsrt.remove(0);
			zamanlarsrt.remove(0);

			Shuffle();

			sounds.insertElementAt("audio/CR.1.wav", 0);
			sounds.insertElementAt("audio/RM.3.wav", 1);
			srt.insertElementAt("text/CR.srt", 0);
			srt.insertElementAt("text/RM.srt", 1);
			zamanlarsrt.insertElementAt("37. 00:03:49  00:03:59 Complaint (negative valence, neutral arousal", 0);
			zamanlarsrt.insertElementAt("5. 00:56:27  00:56:45 Neutral, Content", 1);
			filesToCache.addAll(srt);

			sounds3=(Vector<String>) sounds.clone();
			srt3=(Vector<String>) srt.clone();
			zamanlarsrt3=(Vector<String>) zamanlarsrt.clone();


			sounds.remove(0);
			sounds.remove(0);
			srt.remove(0);
			srt.remove(0);
			zamanlarsrt.remove(0);
			zamanlarsrt.remove(0);		



			TextFile.preCache(MainFrame10.url_addr+"/",filesToCache);

		}

	}





}
