package gui;

import java.util.Vector;

import javax.swing.JButton;

public class MemorizeExperimentDialogSubtitles extends ExperimentDialog {

	FormDialogSubtitles form;
	int resultCount=0;

	public MemorizeExperimentDialogSubtitles(MainFrame10 owner, String title, String instructionText, String fileHeader, String soundFileName,
			Vector<String> sounds, Vector<String>  srtFiles, Vector<String>  srtTimes, int typeExp, JButton toActivate) {
		super(owner,title, instructionText,fileHeader,soundFileName);

		String  fileName = fileHeader+resultCount+"_";
		String attendantNameString = owner.attendantNameString;

		form = new FormDialogSubtitles(this, owner.userFolder,fileName, sounds, srtFiles, srtTimes, typeExp, attendantNameString, toActivate);

	}

	@Override
	void ucDialogClose() {
		super.ucDialogClose();
		form.fileName = fileHeader+resultCount+"_";
		form.outputFolder = owner.userFolder;
		form.setVisible(true);
		resultCount++;
	}
	
	public void setAttendantNameString(String name) {
		form.setAttendantNameString(name);
	}
}
