package gui;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;



public class Questionnaire extends JDialog implements ActionListener{
	
	MainFrame10 owner;
	JButton saveBut;
	JRadioButton quest1Radio1;
	JRadioButton quest1Radio2;
	JRadioButton quest3Radio1;
	JRadioButton quest3Radio2;
	JRadioButton quest4Radio1;
	JRadioButton quest4Radio2;
	JRadioButton quest4Radio3;
	JRadioButton quest4Radio4;
	JRadioButton quest6Radio1;
	JRadioButton quest6Radio2;
	JRadioButton quest6Radio3;
	JRadioButton quest6Radio4;
	JLabel quest1;
	String quest1String="Do you think the instructions were clear enough?";
	String quest1Answer="null";
	String quest1RadioString1="Yes";
	String quest1RadioString2="No";
	String quest3String="Do you think you understood SAM figures and the way to rate?";
	String quest3Answer="null";
	String quest3RadioString1="Yes";
	String quest3RadioString2="No";
	String quest4String="How often do you think you were confident rating the clips?";
	String quest4RadioString1="Never";
	String quest4RadioString2="Seldom";
	String quest4RadioString3="Often";
	String quest4RadioString4="Always";
	String quest4Answer="null";
	String quest6String="What do you think about the length of the experiment?";
	String quest6Answer="null";
	String quest6RadioString1="Short";
	String quest6RadioString2="Fine";
	String quest6RadioString3="Long";
	String quest6RadioString4="Too Long";
	String quest2String="<html>If you answered 'No', could you please explain why <br> and give any suggestions to improve?</html>";
	String quest5String="<html>If you answered 'Never' or 'Seldom', could you please explain why <br> (tired, confused about rating way and figures, confused about feeling expressed etc)</html>";
	JLabel quest2;
	JLabel quest3;
	JLabel quest4;
	JLabel quest5;
	JLabel quest6;
	JTextField quest2Field;
	JTextField quest5Field;
	String quest2Answer="null";
	String quest5Answer="null";
	private String attendantNameString="null";
	String lineEnd="\r\n";
	
	public void setAttendantNameString(String attendantNameString) {
		this.attendantNameString = attendantNameString;
	}

	public Questionnaire(MainFrame10 owner, String attendantNameString) {
		super();
		
		this.owner=owner;
		this.attendantNameString=attendantNameString;
		
		saveBut = new JButton("Save");
		saveBut.setVisible(true);
		saveBut.addActionListener(this);
		
		
		quest1 = new JLabel(quest1String);

		
		quest1Radio1 = new JRadioButton(quest1RadioString1);
		quest1Radio2 = new JRadioButton(quest1RadioString2);

		ButtonGroup groupBut = new ButtonGroup();
		groupBut.add(quest1Radio1);
		groupBut.add(quest1Radio2);

		quest1Radio1.setSelected(false);
		quest1Radio2.setSelected(false);

		quest1Radio1.addActionListener(this);
		quest1Radio2.addActionListener(this);

		JPanel quest1Panel=new JPanel();
		quest1Panel.setLayout(new GridBagLayout());
		quest1Panel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c0 = new GridBagConstraints();
		c0.gridx = 0;
		c0.gridy = 0;
		c0.weightx = 1.0;
		c0.gridwidth = 2;
		quest1Panel.add(quest1,c0);
		c0.gridx = 0;
		c0.gridy = 1;
		c0.weightx = 1.0;
		c0.gridwidth = 1;
		quest1Panel.add(quest1Radio1,c0);
		c0.gridx = 1;
		c0.gridy = 1;
		c0.weightx = 1.0;
		c0.gridwidth = 1;
		quest1Panel.add(quest1Radio2,c0);
		
		
		quest2 = new JLabel(quest2String);
		
		quest2Field = new JTextField("Write your answer here please.");
					
		JPanel quest2Panel=new JPanel();
		quest2Panel.setLayout(new GridBagLayout());
		quest2Panel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c1 = new GridBagConstraints();
		c1.gridx = 0;
		c1.gridy = 0;
		c1.weightx = 1.0;
		c1.weighty = 1.0;
		c1.gridwidth = 1;
		quest2Panel.add(quest2,c1);
		c1.fill=GridBagConstraints.BOTH;
		c1.gridx = 0;
		c1.gridy = 1;
		c1.weightx = 1.0;
		c1.weighty = 1.0;
		c1.gridwidth = 1;
		quest2Panel.add(quest2Field,c1);

		
		quest3 = new JLabel(quest3String);
		
		quest3Radio1 = new JRadioButton(quest3RadioString1);
		quest3Radio2 = new JRadioButton(quest3RadioString2);

		ButtonGroup groupBut3 = new ButtonGroup();
		groupBut3.add(quest3Radio1);
		groupBut3.add(quest3Radio2);

		quest3Radio1.setSelected(false);
		quest3Radio2.setSelected(false);

		quest3Radio1.addActionListener(this);
		quest3Radio2.addActionListener(this);

		JPanel quest3Panel=new JPanel();
		quest3Panel.setLayout(new GridBagLayout());
		quest3Panel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c3 = new GridBagConstraints();
		c3.gridx = 0;
		c3.gridy = 0;
		c3.weightx = 1.0;
		c3.gridwidth = 2;
		quest3Panel.add(quest3,c3);
		c3.gridx = 0;
		c3.gridy = 1;
		c3.weightx = 1.0;
		c3.gridwidth = 1;
		quest3Panel.add(quest3Radio1,c3);
		c3.gridx = 1;
		c3.gridy = 1;
		c3.weightx = 1.0;
		c3.gridwidth = 1;
		quest3Panel.add(quest3Radio2,c3);
		
		quest4 = new JLabel(quest4String);
		
		quest4Radio1 = new JRadioButton(quest4RadioString1);
		quest4Radio2 = new JRadioButton(quest4RadioString2);
		quest4Radio3 = new JRadioButton(quest4RadioString3);
		quest4Radio4 = new JRadioButton(quest4RadioString4);

		ButtonGroup groupBut4 = new ButtonGroup();
		groupBut4.add(quest4Radio1);
		groupBut4.add(quest4Radio2);
		groupBut4.add(quest4Radio3);
		groupBut4.add(quest4Radio4);

		quest4Radio1.setSelected(false);
		quest4Radio2.setSelected(false);
		quest4Radio3.setSelected(false);
		quest4Radio4.setSelected(false);

		quest4Radio1.addActionListener(this);
		quest4Radio2.addActionListener(this);
		quest4Radio3.addActionListener(this);
		quest4Radio4.addActionListener(this);

		JPanel quest4Panel=new JPanel();
		quest4Panel.setLayout(new GridBagLayout());
		quest4Panel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c6 = new GridBagConstraints();
		c6.gridx = 0;
		c6.gridy = 0;
		c6.weightx = 1.0;
		c6.gridwidth = 4;
		quest4Panel.add(quest4,c6);
		c6.gridx = 0;
		c6.gridy = 1;
		c6.weightx = 1.0;
		c6.gridwidth = 1;
		quest4Panel.add(quest4Radio1,c6);
		c6.gridx = 1;
		c6.gridy = 1;
		c6.weightx = 1.0;
		c6.gridwidth = 1;
		quest4Panel.add(quest4Radio2,c6);
		c6.gridx = 2;
		c6.gridy = 1;
		c6.weightx = 1.0;
		c6.gridwidth = 1;
		quest4Panel.add(quest4Radio3,c6);
		c6.gridx = 3;
		c6.gridy = 1;
		c6.weightx = 1.0;
		c6.gridwidth = 1;
		quest4Panel.add(quest4Radio4,c6);
		
		
		quest5 = new JLabel(quest5String);
		
		quest5Field = new JTextField("Write your answer here please.");
					
		JPanel quest5Panel=new JPanel();
		quest5Panel.setLayout(new GridBagLayout());
		quest5Panel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c5 = new GridBagConstraints();
		c5.gridx = 0;
		c5.gridy = 0;
		c5.weightx = 1.0;
		c5.weighty = 1.0;
		c5.gridwidth = 1;
		quest5Panel.add(quest5,c5);
		c5.fill=GridBagConstraints.BOTH;
		c5.gridx = 0;
		c5.gridy = 1;
		c5.weightx = 1.0;
		c5.weighty = 1.0;
		c5.gridwidth = 1;
		quest5Panel.add(quest5Field,c5);
		
		
		quest6 = new JLabel(quest6String);
		
		quest6Radio1 = new JRadioButton(quest6RadioString1);
		quest6Radio2 = new JRadioButton(quest6RadioString2);
		quest6Radio3 = new JRadioButton(quest6RadioString3);
		quest6Radio4 = new JRadioButton(quest6RadioString4);

		ButtonGroup groupBut6 = new ButtonGroup();
		groupBut6.add(quest6Radio1);
		groupBut6.add(quest6Radio2);
		groupBut6.add(quest6Radio3);
		groupBut6.add(quest6Radio4);

		quest6Radio1.setSelected(false);
		quest6Radio2.setSelected(false);
		quest6Radio3.setSelected(false);
		quest6Radio4.setSelected(false);

		quest6Radio1.addActionListener(this);
		quest6Radio2.addActionListener(this);
		quest6Radio3.addActionListener(this);
		quest6Radio4.addActionListener(this);

		JPanel quest6Panel=new JPanel();
		quest6Panel.setLayout(new GridBagLayout());
		quest6Panel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		
		GridBagConstraints c4 = new GridBagConstraints();
		c4.gridx = 0;
		c4.gridy = 0;
		c4.weightx = 1.0;
		c4.gridwidth = 4;
		quest6Panel.add(quest6,c4);
		c4.gridx = 0;
		c4.gridy = 1;
		c4.weightx = 1.0;
		c4.gridwidth = 1;
		quest6Panel.add(quest6Radio1,c4);
		c4.gridx = 1;
		c4.gridy = 1;
		c4.weightx = 1.0;
		c4.gridwidth = 1;
		quest6Panel.add(quest6Radio2,c4);
		c4.gridx = 2;
		c4.gridy = 1;
		c4.weightx = 1.0;
		c4.gridwidth = 1;
		quest6Panel.add(quest6Radio3,c4);
		c4.gridx = 3;
		c4.gridy = 1;
		c4.weightx = 1.0;
		c4.gridwidth = 1;
		quest6Panel.add(quest6Radio4,c4);
		
		
		Container cPane = getContentPane();
		GridLayout mainLayout = new GridLayout(7,1);
		cPane.setLayout(mainLayout);
		
		cPane.add(quest1Panel);
		cPane.add(quest2Panel);
		cPane.add(quest3Panel);
		cPane.add(quest4Panel);
		cPane.add(quest5Panel);
		cPane.add(quest6Panel);
		cPane.add(saveBut);
		
		setLocationRelativeTo(owner);
		setSize(400,300);
				
		pack();
	
	}
	
	public void actionPerformed(ActionEvent e) {
		
		if(e.getSource()==quest1Radio1){
			quest1Answer = quest1RadioString1;
		}
		if(e.getSource()==quest1Radio2){
			quest1Answer = quest1RadioString2;
		}
		
		if(e.getSource()==quest3Radio1){
			quest3Answer = quest3RadioString1;
		}
		if(e.getSource()==quest3Radio2){
			quest3Answer = quest3RadioString2;
		}
		
		if(e.getSource()==quest4Radio1){
			quest4Answer = quest4RadioString1;
		}
		if(e.getSource()==quest4Radio2){
			quest4Answer = quest4RadioString2;
		}
		if(e.getSource()==quest4Radio3){
			quest4Answer = quest4RadioString3;
		}
		if(e.getSource()==quest4Radio4){
			quest4Answer = quest4RadioString4;
		}
		
		if(e.getSource()==quest6Radio1){
			quest6Answer = quest6RadioString1;
		}
		if(e.getSource()==quest6Radio2){
			quest6Answer = quest6RadioString2;
		}
		if(e.getSource()==quest6Radio3){
			quest6Answer = quest6RadioString3;
		}
		if(e.getSource()==quest6Radio4){
			quest6Answer = quest6RadioString4;
		}
		
		if(e.getSource()==saveBut){
			
			quest2Answer=quest2Field.getText();
			quest5Answer=quest5Field.getText();
			
			String questionnaireAnswers= owner.CurrentDate() + lineEnd + "A1) " + quest1Answer + lineEnd +  "A2) " + quest2Answer + lineEnd + "A3) " + quest3Answer + lineEnd + "A4) " + quest4Answer + lineEnd + "A5) " + quest5Answer + lineEnd + "A6) " + quest6Answer + lineEnd;
			
			
			boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, "questionnaire.dat", questionnaireAnswers);
			if(!success){
				MainFrame10.WriteSuccessError();
			}
			
			setVisible(false);
			
		}
		
	}
	

	
}